Date.prototype.format = function(fmt) {
    var o = {
        "M+": this.getMonth() + 1, //月份
        "d+": this.getDate(), //日
        "h+": this.getHours(), //小时
        "m+": this.getMinutes(), //分
        "s+": this.getSeconds(), //秒
        "q+": Math.floor((this.getMonth() + 3) / 3), //季度
        "S": this.getMilliseconds() //毫秒
    };
    if (/(y+)/.test(fmt))
        fmt = fmt.replace(RegExp.$1, (this.getFullYear() + "").substr(4 - RegExp.$1.length));
    for (var k in o)
        if (new RegExp("(" + k + ")").test(fmt))
            fmt = fmt.replace(RegExp.$1, (RegExp.$1.length == 1) ? (o[k]) : (("00" + o[k]).substr(("" + o[k]).length)));
    return fmt;
};

var sizeof = function(str, charset){
    var total = 0,
        charCode,
        i,
        len;
    charset = charset ? charset.toLowerCase() : '';
    if(charset === 'utf-16' || charset === 'utf16'){
        for(i = 0, len = str.length; i < len; i++){
            charCode = str.charCodeAt(i);
            if(charCode <= 0xffff){
                total += 2;
            }else{
                total += 4;
            }
        }
    }else{
        for(i = 0, len = str.length; i < len; i++){
            charCode = str.charCodeAt(i);
            if(charCode <= 0x007f) {
                total += 1;
            }else if(charCode <= 0x07ff){
                total += 2;
            }else if(charCode <= 0xffff){
                total += 3;
            }else{
                total += 4;
            }
        }
    }
    return total;
}

function substr(str, len)
{
    if(!str || !len) { return ''; }
 
    //预期计数：中文2字节，英文1字节
    var a = 0;
 
    //循环计数
    var i = 0;
 
    //临时字串
    var temp = '';
 
    for (i=0;i<str.length;i++)
    {
        if (str.charCodeAt(i)>255) 
        {
            //按照预期计数增加2
            a+=2;
        }
        else
        {
            a++;
        }
        //如果增加计数后长度大于限定长度，就直接返回临时字符串
        if(a > len) { return temp; }
 
        //将当前内容加到临时字符串
        temp += str.charAt(i);
    }
    //如果全部是单字节字符，就直接返回源字符串
    return str;
}

var cache = {};
function tmpl(str, data) {
    var fn = !/\W/.test(str) ? cache[str] = cache[str] || tmpl(document.getElementById(str).innerHTML) :
    new Function("obj", "var p=[],print=function(){p.push.apply(p,arguments);};" +
    "with(obj){p.push('" +
    str
    .replace(/[\r\t\n]/g, " ")
    .split("<%")
    .join("\t")
    .replace(/((^|%>)[^\t]*)'/g, "$1\r")
    .replace(/\t=(.*?)%>/g, "',$1,'")
    .split("\t")
    .join("');")
    .split("%>")
    .join("p.push('")
    .split("\r")
    .join("\\'") + "');}return p.join('');");
    return data ? fn(data) : fn;
}

var nativeUserInfo = JSON.parse(app.getSysInfo())
var commonUserInfo = {
	sGuid: nativeUserInfo.guid,
	sImei: nativeUserInfo.imei,
	sQua: nativeUserInfo.qua
}

var getQueryString = function(key, url) {
    var url = url || location.href
    var queryString = url.substr(url.lastIndexOf('?') + 1)
    var query = queryString.split('&')
    try {
        for (var i = 0; i < query.length; i++) {
            var pair = query[i].split('=')
            if (pair[0] == key) {
                return pair[1]
            }
        }
    } catch(e) {
        return ''
    }
}

var CHANNELS = {
    1:'channel_restart',
    2:'channel_battery',
    3:'channel_talk',
    4:'channel_network',
    5:'channel_desktop',
    8:'channel_advise',
    10:'channle_album',
    11:'channel_clock',
    12:'channel_calendar',
    13:'channel_map',
    14:'channel_weather',
    15:'channel_appmarket',
    16:'channel_browser',
    17:'channel_application_operations',
    18:'channel_background',
    19:'channel_notifications',
    20:'channel_mobile_switch',
    21:'channel_phone',
    22:'channel_message',
    23:'channel_myfiles',
    24:'channel_manager',
    25:'channel_settings',
    26:'channel_datausage',
    27:'channel_OtherAPPs'
}

var CHANNELS_SPEC = {
    'application': 'channel_applications',
    'systemadmin': 'channel_sysadmin'
}

var CHANNELS_SPEC_CHILDS = {
    'application': [21, 22, null, 10, 11, 12, 23, null, 13, 14, 15, 16, null, 24, 25, 26, 27],
    'systemadmin': [17, 18, 19, 20]
}

var CONFIG = app.getConfig()
if (typeof CONFIG === 'string') {
    CONFIG = JSON.parse(CONFIG)
}
CONFIG.local = 'http://' + CONFIG.webHost + '/local'
CONFIG.server = 'http://' + CONFIG.webHost + '/AjaxComm?'